package amptest

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateRules invokes the amptest.CreateRules API synchronously
func (client *Client) CreateRules(request *CreateRulesRequest) (response *CreateRulesResponse, err error) {
	response = CreateCreateRulesResponse()
	err = client.DoAction(request, response)
	return
}

// CreateRulesWithChan invokes the amptest.CreateRules API asynchronously
func (client *Client) CreateRulesWithChan(request *CreateRulesRequest) (<-chan *CreateRulesResponse, <-chan error) {
	responseChan := make(chan *CreateRulesResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateRules(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateRulesWithCallback invokes the amptest.CreateRules API asynchronously
func (client *Client) CreateRulesWithCallback(request *CreateRulesRequest, callback func(response *CreateRulesResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateRulesResponse
		var err error
		defer close(result)
		response, err = client.CreateRules(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateRulesRequest is the request struct for api CreateRules
type CreateRulesRequest struct {
	*requests.RpcRequest
	Home CreateRulesHome `position:"Query" name:"Home"  type:"Struct"`
}

// CreateRulesHome is a repeated param struct in CreateRulesRequest
type CreateRulesHome struct {
	Address      CreateRulesHomeAddress             `name:"Address" type:"Struct"`
	T            CreateRulesHomeT                   `name:"T" type:"Struct"`
	PhoneNumbers *[]string                          `name:"PhoneNumbers" type:"Repeated"`
	DMap         map[string]CreateRulesHomeDMapItem `name:"DMap" type:"Map"`
	NameToAge    map[string]string                  `name:"NameToAge" type:"Map"`
	Locations    *[]CreateRulesHomeLocationsItem    `name:"Locations" type:"Repeated"`
}

// CreateRulesHomeAddress is a repeated param struct in CreateRulesRequest
type CreateRulesHomeAddress struct {
	T        CreateRulesHomeAddressT        `name:"T" type:"Struct"`
	Location CreateRulesHomeAddressLocation `name:"Location" type:"Struct"`
	Detail   string                         `name:"Detail"`
}

// CreateRulesHomeT is a repeated param struct in CreateRulesRequest
type CreateRulesHomeT struct {
	Class string `name:"Class"`
}

// CreateRulesHomeDMapItem is a repeated param struct in CreateRulesRequest
type CreateRulesHomeDMapItem struct {
	Location CreateRulesHomeDMapItemLocation `name:"Location" type:"Struct"`
	Detail   string                          `name:"Detail"`
}

// CreateRulesHomeLocationsItem is a repeated param struct in CreateRulesRequest
type CreateRulesHomeLocationsItem struct {
	Late string `name:"Late"`
	Lon  string `name:"Lon"`
}

// CreateRulesHomeAddressT is a repeated param struct in CreateRulesRequest
type CreateRulesHomeAddressT struct {
	Class string `name:"Class"`
}

// CreateRulesHomeAddressLocation is a repeated param struct in CreateRulesRequest
type CreateRulesHomeAddressLocation struct {
	Late string `name:"Late"`
	Lon  string `name:"Lon"`
}

// CreateRulesHomeDMapItemLocation is a repeated param struct in CreateRulesRequest
type CreateRulesHomeDMapItemLocation struct {
	Late string `name:"Late"`
	Lon  string `name:"Lon"`
}

// CreateRulesResponse is the response struct for api CreateRules
type CreateRulesResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Size      int    `json:"Size" xml:"Size"`
	Value     string `json:"Value" xml:"Value"`
}

// CreateCreateRulesRequest creates a request to invoke CreateRules API
func CreateCreateRulesRequest() (request *CreateRulesRequest) {
	request = &CreateRulesRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("AmpTest", "2020-12-30", "CreateRules", "AmpTest", "openAPI")
	request.Method = requests.POST
	return
}

// CreateCreateRulesResponse creates a response to parse from CreateRules response
func CreateCreateRulesResponse() (response *CreateRulesResponse) {
	response = &CreateRulesResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
