package amptest

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// HuichengTestGrayFifth invokes the amptest.HuichengTestGrayFifth API synchronously
func (client *Client) HuichengTestGrayFifth(request *HuichengTestGrayFifthRequest) (response *HuichengTestGrayFifthResponse, err error) {
	response = CreateHuichengTestGrayFifthResponse()
	err = client.DoAction(request, response)
	return
}

// HuichengTestGrayFifthWithChan invokes the amptest.HuichengTestGrayFifth API asynchronously
func (client *Client) HuichengTestGrayFifthWithChan(request *HuichengTestGrayFifthRequest) (<-chan *HuichengTestGrayFifthResponse, <-chan error) {
	responseChan := make(chan *HuichengTestGrayFifthResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.HuichengTestGrayFifth(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// HuichengTestGrayFifthWithCallback invokes the amptest.HuichengTestGrayFifth API asynchronously
func (client *Client) HuichengTestGrayFifthWithCallback(request *HuichengTestGrayFifthRequest, callback func(response *HuichengTestGrayFifthResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *HuichengTestGrayFifthResponse
		var err error
		defer close(result)
		response, err = client.HuichengTestGrayFifth(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// HuichengTestGrayFifthRequest is the request struct for api HuichengTestGrayFifth
type HuichengTestGrayFifthRequest struct {
	*requests.RpcRequest
	Home HuichengTestGrayFifthHome `position:"Query" name:"Home"  type:"Struct"`
}

// HuichengTestGrayFifthHome is a repeated param struct in HuichengTestGrayFifthRequest
type HuichengTestGrayFifthHome struct {
	Address      HuichengTestGrayFifthHomeAddress             `name:"Address" type:"Struct"`
	T            HuichengTestGrayFifthHomeT                   `name:"T" type:"Struct"`
	PhoneNumbers *[]string                                    `name:"PhoneNumbers" type:"Repeated"`
	DMap         map[string]HuichengTestGrayFifthHomeDMapItem `name:"DMap" type:"Map"`
	NameToAge    map[string]string                            `name:"NameToAge" type:"Map"`
	Locations    *[]HuichengTestGrayFifthHomeLocationsItem    `name:"Locations" type:"Repeated"`
}

// HuichengTestGrayFifthHomeAddress is a repeated param struct in HuichengTestGrayFifthRequest
type HuichengTestGrayFifthHomeAddress struct {
	T        HuichengTestGrayFifthHomeAddressT        `name:"T" type:"Struct"`
	Location HuichengTestGrayFifthHomeAddressLocation `name:"Location" type:"Struct"`
	Detail   string                                   `name:"Detail"`
}

// HuichengTestGrayFifthHomeT is a repeated param struct in HuichengTestGrayFifthRequest
type HuichengTestGrayFifthHomeT struct {
	Class string `name:"Class"`
}

// HuichengTestGrayFifthHomeDMapItem is a repeated param struct in HuichengTestGrayFifthRequest
type HuichengTestGrayFifthHomeDMapItem struct {
	Location HuichengTestGrayFifthHomeDMapItemLocation `name:"Location" type:"Struct"`
	Detail   string                                    `name:"Detail"`
}

// HuichengTestGrayFifthHomeLocationsItem is a repeated param struct in HuichengTestGrayFifthRequest
type HuichengTestGrayFifthHomeLocationsItem struct {
	Late string `name:"Late"`
	Lon  string `name:"Lon"`
}

// HuichengTestGrayFifthHomeAddressT is a repeated param struct in HuichengTestGrayFifthRequest
type HuichengTestGrayFifthHomeAddressT struct {
	Class string `name:"Class"`
}

// HuichengTestGrayFifthHomeAddressLocation is a repeated param struct in HuichengTestGrayFifthRequest
type HuichengTestGrayFifthHomeAddressLocation struct {
	Late string `name:"Late"`
	Lon  string `name:"Lon"`
}

// HuichengTestGrayFifthHomeDMapItemLocation is a repeated param struct in HuichengTestGrayFifthRequest
type HuichengTestGrayFifthHomeDMapItemLocation struct {
	Late string `name:"Late"`
	Lon  string `name:"Lon"`
}

// HuichengTestGrayFifthResponse is the response struct for api HuichengTestGrayFifth
type HuichengTestGrayFifthResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Size      int    `json:"Size" xml:"Size"`
	Value     string `json:"Value" xml:"Value"`
}

// CreateHuichengTestGrayFifthRequest creates a request to invoke HuichengTestGrayFifth API
func CreateHuichengTestGrayFifthRequest() (request *HuichengTestGrayFifthRequest) {
	request = &HuichengTestGrayFifthRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("AmpTest", "2020-12-30", "HuichengTestGrayFifth", "AmpTest", "openAPI")
	request.Method = requests.POST
	return
}

// CreateHuichengTestGrayFifthResponse creates a response to parse from HuichengTestGrayFifth response
func CreateHuichengTestGrayFifthResponse() (response *HuichengTestGrayFifthResponse) {
	response = &HuichengTestGrayFifthResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
