package amptest

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// HuichengTestGrayNine invokes the amptest.HuichengTestGrayNine API synchronously
func (client *Client) HuichengTestGrayNine(request *HuichengTestGrayNineRequest) (response *HuichengTestGrayNineResponse, err error) {
	response = CreateHuichengTestGrayNineResponse()
	err = client.DoAction(request, response)
	return
}

// HuichengTestGrayNineWithChan invokes the amptest.HuichengTestGrayNine API asynchronously
func (client *Client) HuichengTestGrayNineWithChan(request *HuichengTestGrayNineRequest) (<-chan *HuichengTestGrayNineResponse, <-chan error) {
	responseChan := make(chan *HuichengTestGrayNineResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.HuichengTestGrayNine(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// HuichengTestGrayNineWithCallback invokes the amptest.HuichengTestGrayNine API asynchronously
func (client *Client) HuichengTestGrayNineWithCallback(request *HuichengTestGrayNineRequest, callback func(response *HuichengTestGrayNineResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *HuichengTestGrayNineResponse
		var err error
		defer close(result)
		response, err = client.HuichengTestGrayNine(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// HuichengTestGrayNineRequest is the request struct for api HuichengTestGrayNine
type HuichengTestGrayNineRequest struct {
	*requests.RpcRequest
	Home HuichengTestGrayNineHome `position:"Query" name:"Home"  type:"Struct"`
}

// HuichengTestGrayNineHome is a repeated param struct in HuichengTestGrayNineRequest
type HuichengTestGrayNineHome struct {
	Address      HuichengTestGrayNineHomeAddress             `name:"Address" type:"Struct"`
	T            HuichengTestGrayNineHomeT                   `name:"T" type:"Struct"`
	PhoneNumbers *[]string                                   `name:"PhoneNumbers" type:"Repeated"`
	DMap         map[string]HuichengTestGrayNineHomeDMapItem `name:"DMap" type:"Map"`
	NameToAge    map[string]string                           `name:"NameToAge" type:"Map"`
	Locations    *[]HuichengTestGrayNineHomeLocationsItem    `name:"Locations" type:"Repeated"`
}

// HuichengTestGrayNineHomeAddress is a repeated param struct in HuichengTestGrayNineRequest
type HuichengTestGrayNineHomeAddress struct {
	T        HuichengTestGrayNineHomeAddressT        `name:"T" type:"Struct"`
	Location HuichengTestGrayNineHomeAddressLocation `name:"Location" type:"Struct"`
	Detail   string                                  `name:"Detail"`
}

// HuichengTestGrayNineHomeT is a repeated param struct in HuichengTestGrayNineRequest
type HuichengTestGrayNineHomeT struct {
	Class string `name:"Class"`
}

// HuichengTestGrayNineHomeDMapItem is a repeated param struct in HuichengTestGrayNineRequest
type HuichengTestGrayNineHomeDMapItem struct {
	Location HuichengTestGrayNineHomeDMapItemLocation `name:"Location" type:"Struct"`
	Detail   string                                   `name:"Detail"`
}

// HuichengTestGrayNineHomeLocationsItem is a repeated param struct in HuichengTestGrayNineRequest
type HuichengTestGrayNineHomeLocationsItem struct {
	Late string `name:"Late"`
	Lon  string `name:"Lon"`
}

// HuichengTestGrayNineHomeAddressT is a repeated param struct in HuichengTestGrayNineRequest
type HuichengTestGrayNineHomeAddressT struct {
	Class string `name:"Class"`
}

// HuichengTestGrayNineHomeAddressLocation is a repeated param struct in HuichengTestGrayNineRequest
type HuichengTestGrayNineHomeAddressLocation struct {
	Late string `name:"Late"`
	Lon  string `name:"Lon"`
}

// HuichengTestGrayNineHomeDMapItemLocation is a repeated param struct in HuichengTestGrayNineRequest
type HuichengTestGrayNineHomeDMapItemLocation struct {
	Late string `name:"Late"`
	Lon  string `name:"Lon"`
}

// HuichengTestGrayNineResponse is the response struct for api HuichengTestGrayNine
type HuichengTestGrayNineResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Size      int    `json:"Size" xml:"Size"`
	Value     string `json:"Value" xml:"Value"`
}

// CreateHuichengTestGrayNineRequest creates a request to invoke HuichengTestGrayNine API
func CreateHuichengTestGrayNineRequest() (request *HuichengTestGrayNineRequest) {
	request = &HuichengTestGrayNineRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("AmpTest", "2020-12-30", "HuichengTestGrayNine", "AmpTest", "openAPI")
	request.Method = requests.POST
	return
}

// CreateHuichengTestGrayNineResponse creates a response to parse from HuichengTestGrayNine response
func CreateHuichengTestGrayNineResponse() (response *HuichengTestGrayNineResponse) {
	response = &HuichengTestGrayNineResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
