package amptest

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// HuichengTestGrayTen invokes the amptest.HuichengTestGrayTen API synchronously
func (client *Client) HuichengTestGrayTen(request *HuichengTestGrayTenRequest) (response *HuichengTestGrayTenResponse, err error) {
	response = CreateHuichengTestGrayTenResponse()
	err = client.DoAction(request, response)
	return
}

// HuichengTestGrayTenWithChan invokes the amptest.HuichengTestGrayTen API asynchronously
func (client *Client) HuichengTestGrayTenWithChan(request *HuichengTestGrayTenRequest) (<-chan *HuichengTestGrayTenResponse, <-chan error) {
	responseChan := make(chan *HuichengTestGrayTenResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.HuichengTestGrayTen(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// HuichengTestGrayTenWithCallback invokes the amptest.HuichengTestGrayTen API asynchronously
func (client *Client) HuichengTestGrayTenWithCallback(request *HuichengTestGrayTenRequest, callback func(response *HuichengTestGrayTenResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *HuichengTestGrayTenResponse
		var err error
		defer close(result)
		response, err = client.HuichengTestGrayTen(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// HuichengTestGrayTenRequest is the request struct for api HuichengTestGrayTen
type HuichengTestGrayTenRequest struct {
	*requests.RpcRequest
	Home HuichengTestGrayTenHome `position:"Query" name:"Home"  type:"Struct"`
}

// HuichengTestGrayTenHome is a repeated param struct in HuichengTestGrayTenRequest
type HuichengTestGrayTenHome struct {
	Address      HuichengTestGrayTenHomeAddress             `name:"Address" type:"Struct"`
	T            HuichengTestGrayTenHomeT                   `name:"T" type:"Struct"`
	PhoneNumbers *[]string                                  `name:"PhoneNumbers" type:"Repeated"`
	DMap         map[string]HuichengTestGrayTenHomeDMapItem `name:"DMap" type:"Map"`
	NameToAge    map[string]string                          `name:"NameToAge" type:"Map"`
	Locations    *[]HuichengTestGrayTenHomeLocationsItem    `name:"Locations" type:"Repeated"`
}

// HuichengTestGrayTenHomeAddress is a repeated param struct in HuichengTestGrayTenRequest
type HuichengTestGrayTenHomeAddress struct {
	T        HuichengTestGrayTenHomeAddressT        `name:"T" type:"Struct"`
	Location HuichengTestGrayTenHomeAddressLocation `name:"Location" type:"Struct"`
	Detail   string                                 `name:"Detail"`
}

// HuichengTestGrayTenHomeT is a repeated param struct in HuichengTestGrayTenRequest
type HuichengTestGrayTenHomeT struct {
	Class string `name:"Class"`
}

// HuichengTestGrayTenHomeDMapItem is a repeated param struct in HuichengTestGrayTenRequest
type HuichengTestGrayTenHomeDMapItem struct {
	Location HuichengTestGrayTenHomeDMapItemLocation `name:"Location" type:"Struct"`
	Detail   string                                  `name:"Detail"`
}

// HuichengTestGrayTenHomeLocationsItem is a repeated param struct in HuichengTestGrayTenRequest
type HuichengTestGrayTenHomeLocationsItem struct {
	Late string `name:"Late"`
	Lon  string `name:"Lon"`
}

// HuichengTestGrayTenHomeAddressT is a repeated param struct in HuichengTestGrayTenRequest
type HuichengTestGrayTenHomeAddressT struct {
	Class string `name:"Class"`
}

// HuichengTestGrayTenHomeAddressLocation is a repeated param struct in HuichengTestGrayTenRequest
type HuichengTestGrayTenHomeAddressLocation struct {
	Late string `name:"Late"`
	Lon  string `name:"Lon"`
}

// HuichengTestGrayTenHomeDMapItemLocation is a repeated param struct in HuichengTestGrayTenRequest
type HuichengTestGrayTenHomeDMapItemLocation struct {
	Late string `name:"Late"`
	Lon  string `name:"Lon"`
}

// HuichengTestGrayTenResponse is the response struct for api HuichengTestGrayTen
type HuichengTestGrayTenResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Size      int    `json:"Size" xml:"Size"`
	Value     string `json:"Value" xml:"Value"`
}

// CreateHuichengTestGrayTenRequest creates a request to invoke HuichengTestGrayTen API
func CreateHuichengTestGrayTenRequest() (request *HuichengTestGrayTenRequest) {
	request = &HuichengTestGrayTenRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("AmpTest", "2020-12-30", "HuichengTestGrayTen", "AmpTest", "openAPI")
	request.Method = requests.POST
	return
}

// CreateHuichengTestGrayTenResponse creates a response to parse from HuichengTestGrayTen response
func CreateHuichengTestGrayTenResponse() (response *HuichengTestGrayTenResponse) {
	response = &HuichengTestGrayTenResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
