package amptest

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// HuichengTestGrayThird invokes the amptest.HuichengTestGrayThird API synchronously
func (client *Client) HuichengTestGrayThird(request *HuichengTestGrayThirdRequest) (response *HuichengTestGrayThirdResponse, err error) {
	response = CreateHuichengTestGrayThirdResponse()
	err = client.DoAction(request, response)
	return
}

// HuichengTestGrayThirdWithChan invokes the amptest.HuichengTestGrayThird API asynchronously
func (client *Client) HuichengTestGrayThirdWithChan(request *HuichengTestGrayThirdRequest) (<-chan *HuichengTestGrayThirdResponse, <-chan error) {
	responseChan := make(chan *HuichengTestGrayThirdResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.HuichengTestGrayThird(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// HuichengTestGrayThirdWithCallback invokes the amptest.HuichengTestGrayThird API asynchronously
func (client *Client) HuichengTestGrayThirdWithCallback(request *HuichengTestGrayThirdRequest, callback func(response *HuichengTestGrayThirdResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *HuichengTestGrayThirdResponse
		var err error
		defer close(result)
		response, err = client.HuichengTestGrayThird(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// HuichengTestGrayThirdRequest is the request struct for api HuichengTestGrayThird
type HuichengTestGrayThirdRequest struct {
	*requests.RpcRequest
	Home HuichengTestGrayThirdHome `position:"Query" name:"Home"  type:"Struct"`
}

// HuichengTestGrayThirdHome is a repeated param struct in HuichengTestGrayThirdRequest
type HuichengTestGrayThirdHome struct {
	Address      HuichengTestGrayThirdHomeAddress             `name:"Address" type:"Struct"`
	T            HuichengTestGrayThirdHomeT                   `name:"T" type:"Struct"`
	PhoneNumbers *[]string                                    `name:"PhoneNumbers" type:"Repeated"`
	DMap         map[string]HuichengTestGrayThirdHomeDMapItem `name:"DMap" type:"Map"`
	NameToAge    map[string]string                            `name:"NameToAge" type:"Map"`
	Locations    *[]HuichengTestGrayThirdHomeLocationsItem    `name:"Locations" type:"Repeated"`
}

// HuichengTestGrayThirdHomeAddress is a repeated param struct in HuichengTestGrayThirdRequest
type HuichengTestGrayThirdHomeAddress struct {
	T        HuichengTestGrayThirdHomeAddressT        `name:"T" type:"Struct"`
	Location HuichengTestGrayThirdHomeAddressLocation `name:"Location" type:"Struct"`
	Detail   string                                   `name:"Detail"`
}

// HuichengTestGrayThirdHomeT is a repeated param struct in HuichengTestGrayThirdRequest
type HuichengTestGrayThirdHomeT struct {
	Class string `name:"Class"`
}

// HuichengTestGrayThirdHomeDMapItem is a repeated param struct in HuichengTestGrayThirdRequest
type HuichengTestGrayThirdHomeDMapItem struct {
	Location HuichengTestGrayThirdHomeDMapItemLocation `name:"Location" type:"Struct"`
	Detail   string                                    `name:"Detail"`
}

// HuichengTestGrayThirdHomeLocationsItem is a repeated param struct in HuichengTestGrayThirdRequest
type HuichengTestGrayThirdHomeLocationsItem struct {
	Late string `name:"Late"`
	Lon  string `name:"Lon"`
}

// HuichengTestGrayThirdHomeAddressT is a repeated param struct in HuichengTestGrayThirdRequest
type HuichengTestGrayThirdHomeAddressT struct {
	Class string `name:"Class"`
}

// HuichengTestGrayThirdHomeAddressLocation is a repeated param struct in HuichengTestGrayThirdRequest
type HuichengTestGrayThirdHomeAddressLocation struct {
	Late string `name:"Late"`
	Lon  string `name:"Lon"`
}

// HuichengTestGrayThirdHomeDMapItemLocation is a repeated param struct in HuichengTestGrayThirdRequest
type HuichengTestGrayThirdHomeDMapItemLocation struct {
	Late string `name:"Late"`
	Lon  string `name:"Lon"`
}

// HuichengTestGrayThirdResponse is the response struct for api HuichengTestGrayThird
type HuichengTestGrayThirdResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Size      int    `json:"Size" xml:"Size"`
	Value     string `json:"Value" xml:"Value"`
}

// CreateHuichengTestGrayThirdRequest creates a request to invoke HuichengTestGrayThird API
func CreateHuichengTestGrayThirdRequest() (request *HuichengTestGrayThirdRequest) {
	request = &HuichengTestGrayThirdRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("AmpTest", "2020-12-30", "HuichengTestGrayThird", "AmpTest", "openAPI")
	request.Method = requests.POST
	return
}

// CreateHuichengTestGrayThirdResponse creates a response to parse from HuichengTestGrayThird response
func CreateHuichengTestGrayThirdResponse() (response *HuichengTestGrayThirdResponse) {
	response = &HuichengTestGrayThirdResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
