package amptest

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// HuichengTestResourceOwnerId invokes the amptest.HuichengTestResourceOwnerId API synchronously
func (client *Client) HuichengTestResourceOwnerId(request *HuichengTestResourceOwnerIdRequest) (response *HuichengTestResourceOwnerIdResponse, err error) {
	response = CreateHuichengTestResourceOwnerIdResponse()
	err = client.DoAction(request, response)
	return
}

// HuichengTestResourceOwnerIdWithChan invokes the amptest.HuichengTestResourceOwnerId API asynchronously
func (client *Client) HuichengTestResourceOwnerIdWithChan(request *HuichengTestResourceOwnerIdRequest) (<-chan *HuichengTestResourceOwnerIdResponse, <-chan error) {
	responseChan := make(chan *HuichengTestResourceOwnerIdResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.HuichengTestResourceOwnerId(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// HuichengTestResourceOwnerIdWithCallback invokes the amptest.HuichengTestResourceOwnerId API asynchronously
func (client *Client) HuichengTestResourceOwnerIdWithCallback(request *HuichengTestResourceOwnerIdRequest, callback func(response *HuichengTestResourceOwnerIdResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *HuichengTestResourceOwnerIdResponse
		var err error
		defer close(result)
		response, err = client.HuichengTestResourceOwnerId(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// HuichengTestResourceOwnerIdRequest is the request struct for api HuichengTestResourceOwnerId
type HuichengTestResourceOwnerIdRequest struct {
	*requests.RpcRequest
}

// HuichengTestResourceOwnerIdResponse is the response struct for api HuichengTestResourceOwnerId
type HuichengTestResourceOwnerIdResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateHuichengTestResourceOwnerIdRequest creates a request to invoke HuichengTestResourceOwnerId API
func CreateHuichengTestResourceOwnerIdRequest() (request *HuichengTestResourceOwnerIdRequest) {
	request = &HuichengTestResourceOwnerIdRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("AmpTest", "2020-12-30", "HuichengTestResourceOwnerId", "AmpTest", "openAPI")
	request.Method = requests.GET
	return
}

// CreateHuichengTestResourceOwnerIdResponse creates a response to parse from HuichengTestResourceOwnerId response
func CreateHuichengTestResourceOwnerIdResponse() (response *HuichengTestResourceOwnerIdResponse) {
	response = &HuichengTestResourceOwnerIdResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
