package amptest

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// Huichenget invokes the amptest.Huichenget API synchronously
func (client *Client) Huichenget(request *HuichengetRequest) (response *HuichengetResponse, err error) {
	response = CreateHuichengetResponse()
	err = client.DoAction(request, response)
	return
}

// HuichengetWithChan invokes the amptest.Huichenget API asynchronously
func (client *Client) HuichengetWithChan(request *HuichengetRequest) (<-chan *HuichengetResponse, <-chan error) {
	responseChan := make(chan *HuichengetResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.Huichenget(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// HuichengetWithCallback invokes the amptest.Huichenget API asynchronously
func (client *Client) HuichengetWithCallback(request *HuichengetRequest, callback func(response *HuichengetResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *HuichengetResponse
		var err error
		defer close(result)
		response, err = client.Huichenget(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// HuichengetRequest is the request struct for api Huichenget
type HuichengetRequest struct {
	*requests.RpcRequest
	Add     string `position:"Query" name:"Add"`
	Address string `position:"Query" name:"Address"`
	Six     string `position:"Query" name:"Six"`
	Enight  string `position:"Query" name:"Enight"`
	NewName string `position:"Query" name:"NewName"`
	List    string `position:"Query" name:"List"`
	Two     string `position:"Query" name:"Two"`
	Three   string `position:"Query" name:"Three"`
	Nigh    string `position:"Query" name:"Nigh"`
	Red     string `position:"Query" name:"Red"`
	Apple   string `position:"Query" name:"Apple"`
	Tea     string `position:"Query" name:"Tea"`
	Blue    string `position:"Query" name:"Blue"`
	White   string `position:"Query" name:"White"`
	Four    string `position:"Query" name:"Four"`
	Now     string `position:"Query" name:"Now"`
	Ten     string `position:"Query" name:"Ten"`
	Five    string `position:"Query" name:"Five"`
}

// HuichengetResponse is the response struct for api Huichenget
type HuichengetResponse struct {
	*responses.BaseResponse
	RequestId   string `json:"RequestId" xml:"RequestId"`
	InstanceId4 string `json:"InstanceId4" xml:"InstanceId4"`
	Message     string `json:"Message" xml:"Message"`
	Code        string `json:"Code" xml:"Code"`
	Age         string `json:"Age" xml:"Age"`
	Apple       string `json:"Apple" xml:"Apple"`
	Five        string `json:"Five" xml:"Five"`
	Six         string `json:"Six" xml:"Six"`
	Seven       string `json:"Seven" xml:"Seven"`
}

// CreateHuichengetRequest creates a request to invoke Huichenget API
func CreateHuichengetRequest() (request *HuichengetRequest) {
	request = &HuichengetRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("AmpTest", "2020-12-30", "Huichenget", "AmpTest", "openAPI")
	request.Method = requests.POST
	return
}

// CreateHuichengetResponse creates a response to parse from Huichenget response
func CreateHuichengetResponse() (response *HuichengetResponse) {
	response = &HuichengetResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
