package cbn

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeCenVpcFlowStatisticSwitch invokes the cbn.DescribeCenVpcFlowStatisticSwitch API synchronously
func (client *Client) DescribeCenVpcFlowStatisticSwitch(request *DescribeCenVpcFlowStatisticSwitchRequest) (response *DescribeCenVpcFlowStatisticSwitchResponse, err error) {
	response = CreateDescribeCenVpcFlowStatisticSwitchResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeCenVpcFlowStatisticSwitchWithChan invokes the cbn.DescribeCenVpcFlowStatisticSwitch API asynchronously
func (client *Client) DescribeCenVpcFlowStatisticSwitchWithChan(request *DescribeCenVpcFlowStatisticSwitchRequest) (<-chan *DescribeCenVpcFlowStatisticSwitchResponse, <-chan error) {
	responseChan := make(chan *DescribeCenVpcFlowStatisticSwitchResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeCenVpcFlowStatisticSwitch(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeCenVpcFlowStatisticSwitchWithCallback invokes the cbn.DescribeCenVpcFlowStatisticSwitch API asynchronously
func (client *Client) DescribeCenVpcFlowStatisticSwitchWithCallback(request *DescribeCenVpcFlowStatisticSwitchRequest, callback func(response *DescribeCenVpcFlowStatisticSwitchResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeCenVpcFlowStatisticSwitchResponse
		var err error
		defer close(result)
		response, err = client.DescribeCenVpcFlowStatisticSwitch(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeCenVpcFlowStatisticSwitchRequest is the request struct for api DescribeCenVpcFlowStatisticSwitch
type DescribeCenVpcFlowStatisticSwitchRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	CenId                string           `position:"Query" name:"CenId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
}

// DescribeCenVpcFlowStatisticSwitchResponse is the response struct for api DescribeCenVpcFlowStatisticSwitch
type DescribeCenVpcFlowStatisticSwitchResponse struct {
	*responses.BaseResponse
	RequestId   string `json:"RequestId" xml:"RequestId"`
	InvalidDate string `json:"InvalidDate" xml:"InvalidDate"`
	State       string `json:"State" xml:"State"`
	RegionId    string `json:"RegionId" xml:"RegionId"`
	CenId       string `json:"CenId" xml:"CenId"`
}

// CreateDescribeCenVpcFlowStatisticSwitchRequest creates a request to invoke DescribeCenVpcFlowStatisticSwitch API
func CreateDescribeCenVpcFlowStatisticSwitchRequest() (request *DescribeCenVpcFlowStatisticSwitchRequest) {
	request = &DescribeCenVpcFlowStatisticSwitchRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Cbn", "2017-09-12", "DescribeCenVpcFlowStatisticSwitch", "", "")
	request.Method = requests.POST
	return
}

// CreateDescribeCenVpcFlowStatisticSwitchResponse creates a response to parse from DescribeCenVpcFlowStatisticSwitch response
func CreateDescribeCenVpcFlowStatisticSwitchResponse() (response *DescribeCenVpcFlowStatisticSwitchResponse) {
	response = &DescribeCenVpcFlowStatisticSwitchResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
