package cbn

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DisableCenVpcFlowStatistic invokes the cbn.DisableCenVpcFlowStatistic API synchronously
func (client *Client) DisableCenVpcFlowStatistic(request *DisableCenVpcFlowStatisticRequest) (response *DisableCenVpcFlowStatisticResponse, err error) {
	response = CreateDisableCenVpcFlowStatisticResponse()
	err = client.DoAction(request, response)
	return
}

// DisableCenVpcFlowStatisticWithChan invokes the cbn.DisableCenVpcFlowStatistic API asynchronously
func (client *Client) DisableCenVpcFlowStatisticWithChan(request *DisableCenVpcFlowStatisticRequest) (<-chan *DisableCenVpcFlowStatisticResponse, <-chan error) {
	responseChan := make(chan *DisableCenVpcFlowStatisticResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DisableCenVpcFlowStatistic(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DisableCenVpcFlowStatisticWithCallback invokes the cbn.DisableCenVpcFlowStatistic API asynchronously
func (client *Client) DisableCenVpcFlowStatisticWithCallback(request *DisableCenVpcFlowStatisticRequest, callback func(response *DisableCenVpcFlowStatisticResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DisableCenVpcFlowStatisticResponse
		var err error
		defer close(result)
		response, err = client.DisableCenVpcFlowStatistic(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DisableCenVpcFlowStatisticRequest is the request struct for api DisableCenVpcFlowStatistic
type DisableCenVpcFlowStatisticRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ClientToken          string           `position:"Query" name:"ClientToken"`
	CenId                string           `position:"Query" name:"CenId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
}

// DisableCenVpcFlowStatisticResponse is the response struct for api DisableCenVpcFlowStatistic
type DisableCenVpcFlowStatisticResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateDisableCenVpcFlowStatisticRequest creates a request to invoke DisableCenVpcFlowStatistic API
func CreateDisableCenVpcFlowStatisticRequest() (request *DisableCenVpcFlowStatisticRequest) {
	request = &DisableCenVpcFlowStatisticRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Cbn", "2017-09-12", "DisableCenVpcFlowStatistic", "", "")
	request.Method = requests.POST
	return
}

// CreateDisableCenVpcFlowStatisticResponse creates a response to parse from DisableCenVpcFlowStatistic response
func CreateDisableCenVpcFlowStatisticResponse() (response *DisableCenVpcFlowStatisticResponse) {
	response = &DisableCenVpcFlowStatisticResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
