package cbn

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// EnableCenVpcFlowStatistic invokes the cbn.EnableCenVpcFlowStatistic API synchronously
func (client *Client) EnableCenVpcFlowStatistic(request *EnableCenVpcFlowStatisticRequest) (response *EnableCenVpcFlowStatisticResponse, err error) {
	response = CreateEnableCenVpcFlowStatisticResponse()
	err = client.DoAction(request, response)
	return
}

// EnableCenVpcFlowStatisticWithChan invokes the cbn.EnableCenVpcFlowStatistic API asynchronously
func (client *Client) EnableCenVpcFlowStatisticWithChan(request *EnableCenVpcFlowStatisticRequest) (<-chan *EnableCenVpcFlowStatisticResponse, <-chan error) {
	responseChan := make(chan *EnableCenVpcFlowStatisticResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.EnableCenVpcFlowStatistic(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// EnableCenVpcFlowStatisticWithCallback invokes the cbn.EnableCenVpcFlowStatistic API asynchronously
func (client *Client) EnableCenVpcFlowStatisticWithCallback(request *EnableCenVpcFlowStatisticRequest, callback func(response *EnableCenVpcFlowStatisticResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *EnableCenVpcFlowStatisticResponse
		var err error
		defer close(result)
		response, err = client.EnableCenVpcFlowStatistic(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// EnableCenVpcFlowStatisticRequest is the request struct for api EnableCenVpcFlowStatistic
type EnableCenVpcFlowStatisticRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ClientToken          string           `position:"Query" name:"ClientToken"`
	CenId                string           `position:"Query" name:"CenId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	Days                 requests.Integer `position:"Query" name:"Days"`
}

// EnableCenVpcFlowStatisticResponse is the response struct for api EnableCenVpcFlowStatistic
type EnableCenVpcFlowStatisticResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateEnableCenVpcFlowStatisticRequest creates a request to invoke EnableCenVpcFlowStatistic API
func CreateEnableCenVpcFlowStatisticRequest() (request *EnableCenVpcFlowStatisticRequest) {
	request = &EnableCenVpcFlowStatisticRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Cbn", "2017-09-12", "EnableCenVpcFlowStatistic", "", "")
	request.Method = requests.POST
	return
}

// CreateEnableCenVpcFlowStatisticResponse creates a response to parse from EnableCenVpcFlowStatistic response
func CreateEnableCenVpcFlowStatisticResponse() (response *EnableCenVpcFlowStatisticResponse) {
	response = &EnableCenVpcFlowStatisticResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
