package dataworks_public

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListCurrentTasksForResourceGroup invokes the dataworks_public.ListCurrentTasksForResourceGroup API synchronously
func (client *Client) ListCurrentTasksForResourceGroup(request *ListCurrentTasksForResourceGroupRequest) (response *ListCurrentTasksForResourceGroupResponse, err error) {
	response = CreateListCurrentTasksForResourceGroupResponse()
	err = client.DoAction(request, response)
	return
}

// ListCurrentTasksForResourceGroupWithChan invokes the dataworks_public.ListCurrentTasksForResourceGroup API asynchronously
func (client *Client) ListCurrentTasksForResourceGroupWithChan(request *ListCurrentTasksForResourceGroupRequest) (<-chan *ListCurrentTasksForResourceGroupResponse, <-chan error) {
	responseChan := make(chan *ListCurrentTasksForResourceGroupResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListCurrentTasksForResourceGroup(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListCurrentTasksForResourceGroupWithCallback invokes the dataworks_public.ListCurrentTasksForResourceGroup API asynchronously
func (client *Client) ListCurrentTasksForResourceGroupWithCallback(request *ListCurrentTasksForResourceGroupRequest, callback func(response *ListCurrentTasksForResourceGroupResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListCurrentTasksForResourceGroupResponse
		var err error
		defer close(result)
		response, err = client.ListCurrentTasksForResourceGroup(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListCurrentTasksForResourceGroupRequest is the request struct for api ListCurrentTasksForResourceGroup
type ListCurrentTasksForResourceGroupRequest struct {
	*requests.RpcRequest
	ProjectEnv              string           `position:"Body" name:"ProjectEnv"`
	PageSize                requests.Integer `position:"Body" name:"PageSize"`
	ResourceGroupIdentifier string           `position:"Body" name:"ResourceGroupIdentifier"`
	PageNumber              requests.Integer `position:"Body" name:"PageNumber"`
	Status                  requests.Integer `position:"Body" name:"Status"`
}

// ListCurrentTasksForResourceGroupResponse is the response struct for api ListCurrentTasksForResourceGroup
type ListCurrentTasksForResourceGroupResponse struct {
	*responses.BaseResponse
	RequestId      string `json:"RequestId" xml:"RequestId"`
	HttpStatusCode int    `json:"HttpStatusCode" xml:"HttpStatusCode"`
	ErrorMessage   string `json:"ErrorMessage" xml:"ErrorMessage"`
	ErrorCode      string `json:"ErrorCode" xml:"ErrorCode"`
	Success        bool   `json:"Success" xml:"Success"`
	Data           Data   `json:"Data" xml:"Data"`
}

// CreateListCurrentTasksForResourceGroupRequest creates a request to invoke ListCurrentTasksForResourceGroup API
func CreateListCurrentTasksForResourceGroupRequest() (request *ListCurrentTasksForResourceGroupRequest) {
	request = &ListCurrentTasksForResourceGroupRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("dataworks-public", "2020-05-18", "ListCurrentTasksForResourceGroup", "", "")
	request.Method = requests.POST
	return
}

// CreateListCurrentTasksForResourceGroupResponse creates a response to parse from ListCurrentTasksForResourceGroup response
func CreateListCurrentTasksForResourceGroupResponse() (response *ListCurrentTasksForResourceGroupResponse) {
	response = &ListCurrentTasksForResourceGroupResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
