package dataworks_public

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListCurrentUsageForResourceGroup invokes the dataworks_public.ListCurrentUsageForResourceGroup API synchronously
func (client *Client) ListCurrentUsageForResourceGroup(request *ListCurrentUsageForResourceGroupRequest) (response *ListCurrentUsageForResourceGroupResponse, err error) {
	response = CreateListCurrentUsageForResourceGroupResponse()
	err = client.DoAction(request, response)
	return
}

// ListCurrentUsageForResourceGroupWithChan invokes the dataworks_public.ListCurrentUsageForResourceGroup API asynchronously
func (client *Client) ListCurrentUsageForResourceGroupWithChan(request *ListCurrentUsageForResourceGroupRequest) (<-chan *ListCurrentUsageForResourceGroupResponse, <-chan error) {
	responseChan := make(chan *ListCurrentUsageForResourceGroupResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListCurrentUsageForResourceGroup(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListCurrentUsageForResourceGroupWithCallback invokes the dataworks_public.ListCurrentUsageForResourceGroup API asynchronously
func (client *Client) ListCurrentUsageForResourceGroupWithCallback(request *ListCurrentUsageForResourceGroupRequest, callback func(response *ListCurrentUsageForResourceGroupResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListCurrentUsageForResourceGroupResponse
		var err error
		defer close(result)
		response, err = client.ListCurrentUsageForResourceGroup(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListCurrentUsageForResourceGroupRequest is the request struct for api ListCurrentUsageForResourceGroup
type ListCurrentUsageForResourceGroupRequest struct {
	*requests.RpcRequest
	ProjectEnv              string `position:"Body" name:"ProjectEnv"`
	ResourceGroupIdentifier string `position:"Body" name:"ResourceGroupIdentifier"`
}

// ListCurrentUsageForResourceGroupResponse is the response struct for api ListCurrentUsageForResourceGroup
type ListCurrentUsageForResourceGroupResponse struct {
	*responses.BaseResponse
	RequestId      string `json:"RequestId" xml:"RequestId"`
	HttpStatusCode int    `json:"HttpStatusCode" xml:"HttpStatusCode"`
	ErrorMessage   string `json:"ErrorMessage" xml:"ErrorMessage"`
	Success        bool   `json:"Success" xml:"Success"`
	Data           Data   `json:"Data" xml:"Data"`
}

// CreateListCurrentUsageForResourceGroupRequest creates a request to invoke ListCurrentUsageForResourceGroup API
func CreateListCurrentUsageForResourceGroupRequest() (request *ListCurrentUsageForResourceGroupRequest) {
	request = &ListCurrentUsageForResourceGroupRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("dataworks-public", "2020-05-18", "ListCurrentUsageForResourceGroup", "", "")
	request.Method = requests.POST
	return
}

// CreateListCurrentUsageForResourceGroupResponse creates a response to parse from ListCurrentUsageForResourceGroup response
func CreateListCurrentUsageForResourceGroupResponse() (response *ListCurrentUsageForResourceGroupResponse) {
	response = &ListCurrentUsageForResourceGroupResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
