package dataworks_public

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListHistoryTasksForResourceGroup invokes the dataworks_public.ListHistoryTasksForResourceGroup API synchronously
func (client *Client) ListHistoryTasksForResourceGroup(request *ListHistoryTasksForResourceGroupRequest) (response *ListHistoryTasksForResourceGroupResponse, err error) {
	response = CreateListHistoryTasksForResourceGroupResponse()
	err = client.DoAction(request, response)
	return
}

// ListHistoryTasksForResourceGroupWithChan invokes the dataworks_public.ListHistoryTasksForResourceGroup API asynchronously
func (client *Client) ListHistoryTasksForResourceGroupWithChan(request *ListHistoryTasksForResourceGroupRequest) (<-chan *ListHistoryTasksForResourceGroupResponse, <-chan error) {
	responseChan := make(chan *ListHistoryTasksForResourceGroupResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListHistoryTasksForResourceGroup(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListHistoryTasksForResourceGroupWithCallback invokes the dataworks_public.ListHistoryTasksForResourceGroup API asynchronously
func (client *Client) ListHistoryTasksForResourceGroupWithCallback(request *ListHistoryTasksForResourceGroupRequest, callback func(response *ListHistoryTasksForResourceGroupResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListHistoryTasksForResourceGroupResponse
		var err error
		defer close(result)
		response, err = client.ListHistoryTasksForResourceGroup(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListHistoryTasksForResourceGroupRequest is the request struct for api ListHistoryTasksForResourceGroup
type ListHistoryTasksForResourceGroupRequest struct {
	*requests.RpcRequest
	ProjectEnv              string           `position:"Body" name:"ProjectEnv"`
	PageSize                requests.Integer `position:"Body" name:"PageSize"`
	EndTime                 requests.Integer `position:"Body" name:"EndTime"`
	ResourceGroupIdentifier string           `position:"Body" name:"ResourceGroupIdentifier"`
	StartTime               requests.Integer `position:"Body" name:"StartTime"`
	PageNumber              requests.Integer `position:"Body" name:"PageNumber"`
}

// ListHistoryTasksForResourceGroupResponse is the response struct for api ListHistoryTasksForResourceGroup
type ListHistoryTasksForResourceGroupResponse struct {
	*responses.BaseResponse
	RequestId      string `json:"RequestId" xml:"RequestId"`
	HttpStatusCode int    `json:"HttpStatusCode" xml:"HttpStatusCode"`
	ErrorMessage   string `json:"ErrorMessage" xml:"ErrorMessage"`
	ErrorCode      string `json:"ErrorCode" xml:"ErrorCode"`
	Success        bool   `json:"Success" xml:"Success"`
	Data           Data   `json:"Data" xml:"Data"`
}

// CreateListHistoryTasksForResourceGroupRequest creates a request to invoke ListHistoryTasksForResourceGroup API
func CreateListHistoryTasksForResourceGroupRequest() (request *ListHistoryTasksForResourceGroupRequest) {
	request = &ListHistoryTasksForResourceGroupRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("dataworks-public", "2020-05-18", "ListHistoryTasksForResourceGroup", "", "")
	request.Method = requests.POST
	return
}

// CreateListHistoryTasksForResourceGroupResponse creates a response to parse from ListHistoryTasksForResourceGroup response
func CreateListHistoryTasksForResourceGroupResponse() (response *ListHistoryTasksForResourceGroupResponse) {
	response = &ListHistoryTasksForResourceGroupResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
