package dcdn

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DeleteWasm invokes the dcdn.DeleteWasm API synchronously
func (client *Client) DeleteWasm(request *DeleteWasmRequest) (response *DeleteWasmResponse, err error) {
	response = CreateDeleteWasmResponse()
	err = client.DoAction(request, response)
	return
}

// DeleteWasmWithChan invokes the dcdn.DeleteWasm API asynchronously
func (client *Client) DeleteWasmWithChan(request *DeleteWasmRequest) (<-chan *DeleteWasmResponse, <-chan error) {
	responseChan := make(chan *DeleteWasmResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DeleteWasm(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DeleteWasmWithCallback invokes the dcdn.DeleteWasm API asynchronously
func (client *Client) DeleteWasmWithCallback(request *DeleteWasmRequest, callback func(response *DeleteWasmResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DeleteWasmResponse
		var err error
		defer close(result)
		response, err = client.DeleteWasm(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DeleteWasmRequest is the request struct for api DeleteWasm
type DeleteWasmRequest struct {
	*requests.RpcRequest
	OwnerId requests.Integer `position:"Query" name:"OwnerId"`
	Name    string           `position:"Body" name:"Name"`
}

// DeleteWasmResponse is the response struct for api DeleteWasm
type DeleteWasmResponse struct {
	*responses.BaseResponse
	Content   map[string]interface{} `json:"Content" xml:"Content"`
	RequestId string                 `json:"RequestId" xml:"RequestId"`
}

// CreateDeleteWasmRequest creates a request to invoke DeleteWasm API
func CreateDeleteWasmRequest() (request *DeleteWasmRequest) {
	request = &DeleteWasmRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("dcdn", "2018-01-15", "DeleteWasm", "", "")
	request.Method = requests.POST
	return
}

// CreateDeleteWasmResponse creates a response to parse from DeleteWasm response
func CreateDeleteWasmResponse() (response *DeleteWasmResponse) {
	response = &DeleteWasmResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
