package dcdn

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DeleteWasmCodeRevision invokes the dcdn.DeleteWasmCodeRevision API synchronously
func (client *Client) DeleteWasmCodeRevision(request *DeleteWasmCodeRevisionRequest) (response *DeleteWasmCodeRevisionResponse, err error) {
	response = CreateDeleteWasmCodeRevisionResponse()
	err = client.DoAction(request, response)
	return
}

// DeleteWasmCodeRevisionWithChan invokes the dcdn.DeleteWasmCodeRevision API asynchronously
func (client *Client) DeleteWasmCodeRevisionWithChan(request *DeleteWasmCodeRevisionRequest) (<-chan *DeleteWasmCodeRevisionResponse, <-chan error) {
	responseChan := make(chan *DeleteWasmCodeRevisionResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DeleteWasmCodeRevision(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DeleteWasmCodeRevisionWithCallback invokes the dcdn.DeleteWasmCodeRevision API asynchronously
func (client *Client) DeleteWasmCodeRevisionWithCallback(request *DeleteWasmCodeRevisionRequest, callback func(response *DeleteWasmCodeRevisionResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DeleteWasmCodeRevisionResponse
		var err error
		defer close(result)
		response, err = client.DeleteWasmCodeRevision(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DeleteWasmCodeRevisionRequest is the request struct for api DeleteWasmCodeRevision
type DeleteWasmCodeRevisionRequest struct {
	*requests.RpcRequest
	SelectCodeRevision string           `position:"Body" name:"SelectCodeRevision"`
	OwnerId            requests.Integer `position:"Query" name:"OwnerId"`
	Name               string           `position:"Body" name:"Name"`
}

// DeleteWasmCodeRevisionResponse is the response struct for api DeleteWasmCodeRevision
type DeleteWasmCodeRevisionResponse struct {
	*responses.BaseResponse
	Content   map[string]interface{} `json:"Content" xml:"Content"`
	RequestId string                 `json:"RequestId" xml:"RequestId"`
}

// CreateDeleteWasmCodeRevisionRequest creates a request to invoke DeleteWasmCodeRevision API
func CreateDeleteWasmCodeRevisionRequest() (request *DeleteWasmCodeRevisionRequest) {
	request = &DeleteWasmCodeRevisionRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("dcdn", "2018-01-15", "DeleteWasmCodeRevision", "", "")
	request.Method = requests.POST
	return
}

// CreateDeleteWasmCodeRevisionResponse creates a response to parse from DeleteWasmCodeRevision response
func CreateDeleteWasmCodeRevisionResponse() (response *DeleteWasmCodeRevisionResponse) {
	response = &DeleteWasmCodeRevisionResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
