package dcdn

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeDcdnL2VipsByDomain invokes the dcdn.DescribeDcdnL2VipsByDomain API synchronously
func (client *Client) DescribeDcdnL2VipsByDomain(request *DescribeDcdnL2VipsByDomainRequest) (response *DescribeDcdnL2VipsByDomainResponse, err error) {
	response = CreateDescribeDcdnL2VipsByDomainResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeDcdnL2VipsByDomainWithChan invokes the dcdn.DescribeDcdnL2VipsByDomain API asynchronously
func (client *Client) DescribeDcdnL2VipsByDomainWithChan(request *DescribeDcdnL2VipsByDomainRequest) (<-chan *DescribeDcdnL2VipsByDomainResponse, <-chan error) {
	responseChan := make(chan *DescribeDcdnL2VipsByDomainResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeDcdnL2VipsByDomain(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeDcdnL2VipsByDomainWithCallback invokes the dcdn.DescribeDcdnL2VipsByDomain API asynchronously
func (client *Client) DescribeDcdnL2VipsByDomainWithCallback(request *DescribeDcdnL2VipsByDomainRequest, callback func(response *DescribeDcdnL2VipsByDomainResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeDcdnL2VipsByDomainResponse
		var err error
		defer close(result)
		response, err = client.DescribeDcdnL2VipsByDomain(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeDcdnL2VipsByDomainRequest is the request struct for api DescribeDcdnL2VipsByDomain
type DescribeDcdnL2VipsByDomainRequest struct {
	*requests.RpcRequest
	DomainName string           `position:"Query" name:"DomainName"`
	OwnerId    requests.Integer `position:"Query" name:"OwnerId"`
}

// DescribeDcdnL2VipsByDomainResponse is the response struct for api DescribeDcdnL2VipsByDomain
type DescribeDcdnL2VipsByDomainResponse struct {
	*responses.BaseResponse
	DomainName string   `json:"DomainName" xml:"DomainName"`
	RequestId  string   `json:"RequestId" xml:"RequestId"`
	Vips       []string `json:"Vips" xml:"Vips"`
}

// CreateDescribeDcdnL2VipsByDomainRequest creates a request to invoke DescribeDcdnL2VipsByDomain API
func CreateDescribeDcdnL2VipsByDomainRequest() (request *DescribeDcdnL2VipsByDomainRequest) {
	request = &DescribeDcdnL2VipsByDomainRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("dcdn", "2018-01-15", "DescribeDcdnL2VipsByDomain", "", "")
	request.Method = requests.POST
	return
}

// CreateDescribeDcdnL2VipsByDomainResponse creates a response to parse from DescribeDcdnL2VipsByDomain response
func CreateDescribeDcdnL2VipsByDomainResponse() (response *DescribeDcdnL2VipsByDomainResponse) {
	response = &DescribeDcdnL2VipsByDomainResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
