package dcdn

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeWasm invokes the dcdn.DescribeWasm API synchronously
func (client *Client) DescribeWasm(request *DescribeWasmRequest) (response *DescribeWasmResponse, err error) {
	response = CreateDescribeWasmResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeWasmWithChan invokes the dcdn.DescribeWasm API asynchronously
func (client *Client) DescribeWasmWithChan(request *DescribeWasmRequest) (<-chan *DescribeWasmResponse, <-chan error) {
	responseChan := make(chan *DescribeWasmResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeWasm(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeWasmWithCallback invokes the dcdn.DescribeWasm API asynchronously
func (client *Client) DescribeWasmWithCallback(request *DescribeWasmRequest, callback func(response *DescribeWasmResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeWasmResponse
		var err error
		defer close(result)
		response, err = client.DescribeWasm(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeWasmRequest is the request struct for api DescribeWasm
type DescribeWasmRequest struct {
	*requests.RpcRequest
	OwnerId requests.Integer `position:"Query" name:"OwnerId"`
	Name    string           `position:"Body" name:"Name"`
}

// DescribeWasmResponse is the response struct for api DescribeWasm
type DescribeWasmResponse struct {
	*responses.BaseResponse
	Content   map[string]interface{} `json:"Content" xml:"Content"`
	RequestId string                 `json:"RequestId" xml:"RequestId"`
}

// CreateDescribeWasmRequest creates a request to invoke DescribeWasm API
func CreateDescribeWasmRequest() (request *DescribeWasmRequest) {
	request = &DescribeWasmRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("dcdn", "2018-01-15", "DescribeWasm", "", "")
	request.Method = requests.POST
	return
}

// CreateDescribeWasmResponse creates a response to parse from DescribeWasm response
func CreateDescribeWasmResponse() (response *DescribeWasmResponse) {
	response = &DescribeWasmResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
