package dcdn

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeWasmUserInfo invokes the dcdn.DescribeWasmUserInfo API synchronously
func (client *Client) DescribeWasmUserInfo(request *DescribeWasmUserInfoRequest) (response *DescribeWasmUserInfoResponse, err error) {
	response = CreateDescribeWasmUserInfoResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeWasmUserInfoWithChan invokes the dcdn.DescribeWasmUserInfo API asynchronously
func (client *Client) DescribeWasmUserInfoWithChan(request *DescribeWasmUserInfoRequest) (<-chan *DescribeWasmUserInfoResponse, <-chan error) {
	responseChan := make(chan *DescribeWasmUserInfoResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeWasmUserInfo(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeWasmUserInfoWithCallback invokes the dcdn.DescribeWasmUserInfo API asynchronously
func (client *Client) DescribeWasmUserInfoWithCallback(request *DescribeWasmUserInfoRequest, callback func(response *DescribeWasmUserInfoResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeWasmUserInfoResponse
		var err error
		defer close(result)
		response, err = client.DescribeWasmUserInfo(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeWasmUserInfoRequest is the request struct for api DescribeWasmUserInfo
type DescribeWasmUserInfoRequest struct {
	*requests.RpcRequest
	OwnerId requests.Integer `position:"Query" name:"OwnerId"`
}

// DescribeWasmUserInfoResponse is the response struct for api DescribeWasmUserInfo
type DescribeWasmUserInfoResponse struct {
	*responses.BaseResponse
	Content   map[string]interface{} `json:"Content" xml:"Content"`
	RequestId string                 `json:"RequestId" xml:"RequestId"`
}

// CreateDescribeWasmUserInfoRequest creates a request to invoke DescribeWasmUserInfo API
func CreateDescribeWasmUserInfoRequest() (request *DescribeWasmUserInfoRequest) {
	request = &DescribeWasmUserInfoRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("dcdn", "2018-01-15", "DescribeWasmUserInfo", "", "")
	request.Method = requests.POST
	return
}

// CreateDescribeWasmUserInfoResponse creates a response to parse from DescribeWasmUserInfo response
func CreateDescribeWasmUserInfoResponse() (response *DescribeWasmUserInfoResponse) {
	response = &DescribeWasmUserInfoResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
