package dcdn

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// EditWasmConf invokes the dcdn.EditWasmConf API synchronously
func (client *Client) EditWasmConf(request *EditWasmConfRequest) (response *EditWasmConfResponse, err error) {
	response = CreateEditWasmConfResponse()
	err = client.DoAction(request, response)
	return
}

// EditWasmConfWithChan invokes the dcdn.EditWasmConf API asynchronously
func (client *Client) EditWasmConfWithChan(request *EditWasmConfRequest) (<-chan *EditWasmConfResponse, <-chan error) {
	responseChan := make(chan *EditWasmConfResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.EditWasmConf(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// EditWasmConfWithCallback invokes the dcdn.EditWasmConf API asynchronously
func (client *Client) EditWasmConfWithCallback(request *EditWasmConfRequest, callback func(response *EditWasmConfResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *EditWasmConfResponse
		var err error
		defer close(result)
		response, err = client.EditWasmConf(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// EditWasmConfRequest is the request struct for api EditWasmConf
type EditWasmConfRequest struct {
	*requests.RpcRequest
	Description string           `position:"Body" name:"Description"`
	OwnerId     requests.Integer `position:"Query" name:"OwnerId"`
	Name        string           `position:"Body" name:"Name"`
}

// EditWasmConfResponse is the response struct for api EditWasmConf
type EditWasmConfResponse struct {
	*responses.BaseResponse
	Content   map[string]interface{} `json:"Content" xml:"Content"`
	RequestId string                 `json:"RequestId" xml:"RequestId"`
}

// CreateEditWasmConfRequest creates a request to invoke EditWasmConf API
func CreateEditWasmConfRequest() (request *EditWasmConfRequest) {
	request = &EditWasmConfRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("dcdn", "2018-01-15", "EditWasmConf", "", "")
	request.Method = requests.POST
	return
}

// CreateEditWasmConfResponse creates a response to parse from EditWasmConf response
func CreateEditWasmConfResponse() (response *EditWasmConfResponse) {
	response = &EditWasmConfResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
