package live

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeLiveUserQuota invokes the live.DescribeLiveUserQuota API synchronously
func (client *Client) DescribeLiveUserQuota(request *DescribeLiveUserQuotaRequest) (response *DescribeLiveUserQuotaResponse, err error) {
	response = CreateDescribeLiveUserQuotaResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeLiveUserQuotaWithChan invokes the live.DescribeLiveUserQuota API asynchronously
func (client *Client) DescribeLiveUserQuotaWithChan(request *DescribeLiveUserQuotaRequest) (<-chan *DescribeLiveUserQuotaResponse, <-chan error) {
	responseChan := make(chan *DescribeLiveUserQuotaResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeLiveUserQuota(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeLiveUserQuotaWithCallback invokes the live.DescribeLiveUserQuota API asynchronously
func (client *Client) DescribeLiveUserQuotaWithCallback(request *DescribeLiveUserQuotaRequest, callback func(response *DescribeLiveUserQuotaResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeLiveUserQuotaResponse
		var err error
		defer close(result)
		response, err = client.DescribeLiveUserQuota(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeLiveUserQuotaRequest is the request struct for api DescribeLiveUserQuota
type DescribeLiveUserQuotaRequest struct {
	*requests.RpcRequest
	OwnerId       requests.Integer `position:"Query" name:"OwnerId"`
	SecurityToken string           `position:"Query" name:"SecurityToken"`
}

// DescribeLiveUserQuotaResponse is the response struct for api DescribeLiveUserQuota
type DescribeLiveUserQuotaResponse struct {
	*responses.BaseResponse
	DomainQuota     int    `json:"DomainQuota" xml:"DomainQuota"`
	DomainUsedCount string `json:"DomainUsedCount" xml:"DomainUsedCount"`
	RequestId       string `json:"RequestId" xml:"RequestId"`
}

// CreateDescribeLiveUserQuotaRequest creates a request to invoke DescribeLiveUserQuota API
func CreateDescribeLiveUserQuotaRequest() (request *DescribeLiveUserQuotaRequest) {
	request = &DescribeLiveUserQuotaRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("live", "2016-11-01", "DescribeLiveUserQuota", "live", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeLiveUserQuotaResponse creates a response to parse from DescribeLiveUserQuota response
func CreateDescribeLiveUserQuotaResponse() (response *DescribeLiveUserQuotaResponse) {
	response = &DescribeLiveUserQuotaResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
