package live

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// SetLiveDomainSpecialConfig invokes the live.SetLiveDomainSpecialConfig API synchronously
func (client *Client) SetLiveDomainSpecialConfig(request *SetLiveDomainSpecialConfigRequest) (response *SetLiveDomainSpecialConfigResponse, err error) {
	response = CreateSetLiveDomainSpecialConfigResponse()
	err = client.DoAction(request, response)
	return
}

// SetLiveDomainSpecialConfigWithChan invokes the live.SetLiveDomainSpecialConfig API asynchronously
func (client *Client) SetLiveDomainSpecialConfigWithChan(request *SetLiveDomainSpecialConfigRequest) (<-chan *SetLiveDomainSpecialConfigResponse, <-chan error) {
	responseChan := make(chan *SetLiveDomainSpecialConfigResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.SetLiveDomainSpecialConfig(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// SetLiveDomainSpecialConfigWithCallback invokes the live.SetLiveDomainSpecialConfig API asynchronously
func (client *Client) SetLiveDomainSpecialConfigWithCallback(request *SetLiveDomainSpecialConfigRequest, callback func(response *SetLiveDomainSpecialConfigResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *SetLiveDomainSpecialConfigResponse
		var err error
		defer close(result)
		response, err = client.SetLiveDomainSpecialConfig(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// SetLiveDomainSpecialConfigRequest is the request struct for api SetLiveDomainSpecialConfig
type SetLiveDomainSpecialConfigRequest struct {
	*requests.RpcRequest
	Value      string           `position:"Query" name:"Value"`
	DomainName string           `position:"Query" name:"DomainName"`
	OwnerId    requests.Integer `position:"Query" name:"OwnerId"`
	Name       string           `position:"Query" name:"Name"`
}

// SetLiveDomainSpecialConfigResponse is the response struct for api SetLiveDomainSpecialConfig
type SetLiveDomainSpecialConfigResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateSetLiveDomainSpecialConfigRequest creates a request to invoke SetLiveDomainSpecialConfig API
func CreateSetLiveDomainSpecialConfigRequest() (request *SetLiveDomainSpecialConfigRequest) {
	request = &SetLiveDomainSpecialConfigRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("live", "2016-11-01", "SetLiveDomainSpecialConfig", "live", "openAPI")
	request.Method = requests.POST
	return
}

// CreateSetLiveDomainSpecialConfigResponse creates a response to parse from SetLiveDomainSpecialConfig response
func CreateSetLiveDomainSpecialConfigResponse() (response *SetLiveDomainSpecialConfigResponse) {
	response = &SetLiveDomainSpecialConfigResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
