package lmztest

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// AndBack invokes the lmztest.AndBack API synchronously
func (client *Client) AndBack(request *AndBackRequest) (response *AndBackResponse, err error) {
	response = CreateAndBackResponse()
	err = client.DoAction(request, response)
	return
}

// AndBackWithChan invokes the lmztest.AndBack API asynchronously
func (client *Client) AndBackWithChan(request *AndBackRequest) (<-chan *AndBackResponse, <-chan error) {
	responseChan := make(chan *AndBackResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.AndBack(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// AndBackWithCallback invokes the lmztest.AndBack API asynchronously
func (client *Client) AndBackWithCallback(request *AndBackRequest, callback func(response *AndBackResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *AndBackResponse
		var err error
		defer close(result)
		response, err = client.AndBack(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// AndBackRequest is the request struct for api AndBack
type AndBackRequest struct {
	*requests.RpcRequest
	ClientToken2 string `position:"Query" name:"ClientToken2"`
	TestDemo     string `position:"Query" name:"TestDemo"`
}

// AndBackResponse is the response struct for api AndBack
type AndBackResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateAndBackRequest creates a request to invoke AndBack API
func CreateAndBackRequest() (request *AndBackRequest) {
	request = &AndBackRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("LmzTest", "2010-10-11", "AndBack", "", "")
	request.Method = requests.GET
	return
}

// CreateAndBackResponse creates a response to parse from AndBack response
func CreateAndBackResponse() (response *AndBackResponse) {
	response = &AndBackResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
