package lmztest

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DataRateLimitTest invokes the lmztest.DataRateLimitTest API synchronously
func (client *Client) DataRateLimitTest(request *DataRateLimitTestRequest) (response *DataRateLimitTestResponse, err error) {
	response = CreateDataRateLimitTestResponse()
	err = client.DoAction(request, response)
	return
}

// DataRateLimitTestWithChan invokes the lmztest.DataRateLimitTest API asynchronously
func (client *Client) DataRateLimitTestWithChan(request *DataRateLimitTestRequest) (<-chan *DataRateLimitTestResponse, <-chan error) {
	responseChan := make(chan *DataRateLimitTestResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DataRateLimitTest(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DataRateLimitTestWithCallback invokes the lmztest.DataRateLimitTest API asynchronously
func (client *Client) DataRateLimitTestWithCallback(request *DataRateLimitTestRequest, callback func(response *DataRateLimitTestResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DataRateLimitTestResponse
		var err error
		defer close(result)
		response, err = client.DataRateLimitTest(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DataRateLimitTestRequest is the request struct for api DataRateLimitTest
type DataRateLimitTestRequest struct {
	*requests.RpcRequest
}

// DataRateLimitTestResponse is the response struct for api DataRateLimitTest
type DataRateLimitTestResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateDataRateLimitTestRequest creates a request to invoke DataRateLimitTest API
func CreateDataRateLimitTestRequest() (request *DataRateLimitTestRequest) {
	request = &DataRateLimitTestRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("LmzTest", "2010-10-11", "DataRateLimitTest", "", "")
	request.Method = requests.GET
	return
}

// CreateDataRateLimitTestResponse creates a response to parse from DataRateLimitTest response
func CreateDataRateLimitTestResponse() (response *DataRateLimitTestResponse) {
	response = &DataRateLimitTestResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
