package lmztest

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DemoGrayReleaseTest invokes the lmztest.DemoGrayReleaseTest API synchronously
func (client *Client) DemoGrayReleaseTest(request *DemoGrayReleaseTestRequest) (response *DemoGrayReleaseTestResponse, err error) {
	response = CreateDemoGrayReleaseTestResponse()
	err = client.DoAction(request, response)
	return
}

// DemoGrayReleaseTestWithChan invokes the lmztest.DemoGrayReleaseTest API asynchronously
func (client *Client) DemoGrayReleaseTestWithChan(request *DemoGrayReleaseTestRequest) (<-chan *DemoGrayReleaseTestResponse, <-chan error) {
	responseChan := make(chan *DemoGrayReleaseTestResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DemoGrayReleaseTest(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DemoGrayReleaseTestWithCallback invokes the lmztest.DemoGrayReleaseTest API asynchronously
func (client *Client) DemoGrayReleaseTestWithCallback(request *DemoGrayReleaseTestRequest, callback func(response *DemoGrayReleaseTestResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DemoGrayReleaseTestResponse
		var err error
		defer close(result)
		response, err = client.DemoGrayReleaseTest(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DemoGrayReleaseTestRequest is the request struct for api DemoGrayReleaseTest
type DemoGrayReleaseTestRequest struct {
	*requests.RpcRequest
	NumberCode requests.Integer `position:"Query" name:"NumberCode"`
	Id         string           `position:"Query" name:"Id"`
}

// DemoGrayReleaseTestResponse is the response struct for api DemoGrayReleaseTest
type DemoGrayReleaseTestResponse struct {
	*responses.BaseResponse
	RequestId string                 `json:"RequestId" xml:"RequestId"`
	Name      string                 `json:"Name" xml:"Name"`
	Code      map[string]interface{} `json:"Code" xml:"Code"`
}

// CreateDemoGrayReleaseTestRequest creates a request to invoke DemoGrayReleaseTest API
func CreateDemoGrayReleaseTestRequest() (request *DemoGrayReleaseTestRequest) {
	request = &DemoGrayReleaseTestRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("LmzTest", "2010-10-11", "DemoGrayReleaseTest", "", "")
	request.Method = requests.POST
	return
}

// CreateDemoGrayReleaseTestResponse creates a response to parse from DemoGrayReleaseTest response
func CreateDemoGrayReleaseTestResponse() (response *DemoGrayReleaseTestResponse) {
	response = &DemoGrayReleaseTestResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
