package ocr

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// RecognizeRussiaIdentityCard invokes the ocr.RecognizeRussiaIdentityCard API synchronously
func (client *Client) RecognizeRussiaIdentityCard(request *RecognizeRussiaIdentityCardRequest) (response *RecognizeRussiaIdentityCardResponse, err error) {
	response = CreateRecognizeRussiaIdentityCardResponse()
	err = client.DoAction(request, response)
	return
}

// RecognizeRussiaIdentityCardWithChan invokes the ocr.RecognizeRussiaIdentityCard API asynchronously
func (client *Client) RecognizeRussiaIdentityCardWithChan(request *RecognizeRussiaIdentityCardRequest) (<-chan *RecognizeRussiaIdentityCardResponse, <-chan error) {
	responseChan := make(chan *RecognizeRussiaIdentityCardResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.RecognizeRussiaIdentityCard(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// RecognizeRussiaIdentityCardWithCallback invokes the ocr.RecognizeRussiaIdentityCard API asynchronously
func (client *Client) RecognizeRussiaIdentityCardWithCallback(request *RecognizeRussiaIdentityCardRequest, callback func(response *RecognizeRussiaIdentityCardResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *RecognizeRussiaIdentityCardResponse
		var err error
		defer close(result)
		response, err = client.RecognizeRussiaIdentityCard(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// RecognizeRussiaIdentityCardRequest is the request struct for api RecognizeRussiaIdentityCard
type RecognizeRussiaIdentityCardRequest struct {
	*requests.RpcRequest
	ImageUrl string `position:"Body" name:"ImageUrl"`
}

// RecognizeRussiaIdentityCardResponse is the response struct for api RecognizeRussiaIdentityCard
type RecognizeRussiaIdentityCardResponse struct {
	*responses.BaseResponse
	RequestId string                            `json:"RequestId" xml:"RequestId"`
	Code      string                            `json:"Code" xml:"Code"`
	Message   string                            `json:"Message" xml:"Message"`
	Data      DataInRecognizeRussiaIdentityCard `json:"Data" xml:"Data"`
}

// CreateRecognizeRussiaIdentityCardRequest creates a request to invoke RecognizeRussiaIdentityCard API
func CreateRecognizeRussiaIdentityCardRequest() (request *RecognizeRussiaIdentityCardRequest) {
	request = &RecognizeRussiaIdentityCardRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ocr", "2019-12-30", "RecognizeRussiaIdentityCard", "ocr", "openAPI")
	request.Method = requests.POST
	return
}

// CreateRecognizeRussiaIdentityCardResponse creates a response to parse from RecognizeRussiaIdentityCard response
func CreateRecognizeRussiaIdentityCardResponse() (response *RecognizeRussiaIdentityCardResponse) {
	response = &RecognizeRussiaIdentityCardResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
