package ocr

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// RecognizeTurkeyIdentityCard invokes the ocr.RecognizeTurkeyIdentityCard API synchronously
func (client *Client) RecognizeTurkeyIdentityCard(request *RecognizeTurkeyIdentityCardRequest) (response *RecognizeTurkeyIdentityCardResponse, err error) {
	response = CreateRecognizeTurkeyIdentityCardResponse()
	err = client.DoAction(request, response)
	return
}

// RecognizeTurkeyIdentityCardWithChan invokes the ocr.RecognizeTurkeyIdentityCard API asynchronously
func (client *Client) RecognizeTurkeyIdentityCardWithChan(request *RecognizeTurkeyIdentityCardRequest) (<-chan *RecognizeTurkeyIdentityCardResponse, <-chan error) {
	responseChan := make(chan *RecognizeTurkeyIdentityCardResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.RecognizeTurkeyIdentityCard(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// RecognizeTurkeyIdentityCardWithCallback invokes the ocr.RecognizeTurkeyIdentityCard API asynchronously
func (client *Client) RecognizeTurkeyIdentityCardWithCallback(request *RecognizeTurkeyIdentityCardRequest, callback func(response *RecognizeTurkeyIdentityCardResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *RecognizeTurkeyIdentityCardResponse
		var err error
		defer close(result)
		response, err = client.RecognizeTurkeyIdentityCard(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// RecognizeTurkeyIdentityCardRequest is the request struct for api RecognizeTurkeyIdentityCard
type RecognizeTurkeyIdentityCardRequest struct {
	*requests.RpcRequest
	ImageUrl string `position:"Body" name:"ImageUrl"`
}

// RecognizeTurkeyIdentityCardResponse is the response struct for api RecognizeTurkeyIdentityCard
type RecognizeTurkeyIdentityCardResponse struct {
	*responses.BaseResponse
	RequestId string                            `json:"RequestId" xml:"RequestId"`
	Code      string                            `json:"Code" xml:"Code"`
	Message   string                            `json:"Message" xml:"Message"`
	Data      DataInRecognizeTurkeyIdentityCard `json:"Data" xml:"Data"`
}

// CreateRecognizeTurkeyIdentityCardRequest creates a request to invoke RecognizeTurkeyIdentityCard API
func CreateRecognizeTurkeyIdentityCardRequest() (request *RecognizeTurkeyIdentityCardRequest) {
	request = &RecognizeTurkeyIdentityCardRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ocr", "2019-12-30", "RecognizeTurkeyIdentityCard", "ocr", "openAPI")
	request.Method = requests.POST
	return
}

// CreateRecognizeTurkeyIdentityCardResponse creates a response to parse from RecognizeTurkeyIdentityCard response
func CreateRecognizeTurkeyIdentityCardResponse() (response *RecognizeTurkeyIdentityCardResponse) {
	response = &RecognizeTurkeyIdentityCardResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
