package ocr

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// RecognizeUkraineIdentityCard invokes the ocr.RecognizeUkraineIdentityCard API synchronously
func (client *Client) RecognizeUkraineIdentityCard(request *RecognizeUkraineIdentityCardRequest) (response *RecognizeUkraineIdentityCardResponse, err error) {
	response = CreateRecognizeUkraineIdentityCardResponse()
	err = client.DoAction(request, response)
	return
}

// RecognizeUkraineIdentityCardWithChan invokes the ocr.RecognizeUkraineIdentityCard API asynchronously
func (client *Client) RecognizeUkraineIdentityCardWithChan(request *RecognizeUkraineIdentityCardRequest) (<-chan *RecognizeUkraineIdentityCardResponse, <-chan error) {
	responseChan := make(chan *RecognizeUkraineIdentityCardResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.RecognizeUkraineIdentityCard(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// RecognizeUkraineIdentityCardWithCallback invokes the ocr.RecognizeUkraineIdentityCard API asynchronously
func (client *Client) RecognizeUkraineIdentityCardWithCallback(request *RecognizeUkraineIdentityCardRequest, callback func(response *RecognizeUkraineIdentityCardResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *RecognizeUkraineIdentityCardResponse
		var err error
		defer close(result)
		response, err = client.RecognizeUkraineIdentityCard(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// RecognizeUkraineIdentityCardRequest is the request struct for api RecognizeUkraineIdentityCard
type RecognizeUkraineIdentityCardRequest struct {
	*requests.RpcRequest
	ImageUrl string `position:"Body" name:"ImageUrl"`
}

// RecognizeUkraineIdentityCardResponse is the response struct for api RecognizeUkraineIdentityCard
type RecognizeUkraineIdentityCardResponse struct {
	*responses.BaseResponse
	RequestId string                             `json:"RequestId" xml:"RequestId"`
	Code      string                             `json:"Code" xml:"Code"`
	Message   string                             `json:"Message" xml:"Message"`
	Data      DataInRecognizeUkraineIdentityCard `json:"Data" xml:"Data"`
}

// CreateRecognizeUkraineIdentityCardRequest creates a request to invoke RecognizeUkraineIdentityCard API
func CreateRecognizeUkraineIdentityCardRequest() (request *RecognizeUkraineIdentityCardRequest) {
	request = &RecognizeUkraineIdentityCardRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ocr", "2019-12-30", "RecognizeUkraineIdentityCard", "ocr", "openAPI")
	request.Method = requests.POST
	return
}

// CreateRecognizeUkraineIdentityCardResponse creates a response to parse from RecognizeUkraineIdentityCard response
func CreateRecognizeUkraineIdentityCardResponse() (response *RecognizeUkraineIdentityCardResponse) {
	response = &RecognizeUkraineIdentityCardResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
