package scdn

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// TestAmpDescribeScdnDomainIspData invokes the scdn.TestAmpDescribeScdnDomainIspData API synchronously
func (client *Client) TestAmpDescribeScdnDomainIspData(request *TestAmpDescribeScdnDomainIspDataRequest) (response *TestAmpDescribeScdnDomainIspDataResponse, err error) {
	response = CreateTestAmpDescribeScdnDomainIspDataResponse()
	err = client.DoAction(request, response)
	return
}

// TestAmpDescribeScdnDomainIspDataWithChan invokes the scdn.TestAmpDescribeScdnDomainIspData API asynchronously
func (client *Client) TestAmpDescribeScdnDomainIspDataWithChan(request *TestAmpDescribeScdnDomainIspDataRequest) (<-chan *TestAmpDescribeScdnDomainIspDataResponse, <-chan error) {
	responseChan := make(chan *TestAmpDescribeScdnDomainIspDataResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.TestAmpDescribeScdnDomainIspData(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// TestAmpDescribeScdnDomainIspDataWithCallback invokes the scdn.TestAmpDescribeScdnDomainIspData API asynchronously
func (client *Client) TestAmpDescribeScdnDomainIspDataWithCallback(request *TestAmpDescribeScdnDomainIspDataRequest, callback func(response *TestAmpDescribeScdnDomainIspDataResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *TestAmpDescribeScdnDomainIspDataResponse
		var err error
		defer close(result)
		response, err = client.TestAmpDescribeScdnDomainIspData(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// TestAmpDescribeScdnDomainIspDataRequest is the request struct for api TestAmpDescribeScdnDomainIspData
type TestAmpDescribeScdnDomainIspDataRequest struct {
	*requests.RpcRequest
	DomainName string `position:"Query" name:"DomainName"`
	EndTime    string `position:"Query" name:"EndTime"`
	StartTime  string `position:"Query" name:"StartTime"`
}

// TestAmpDescribeScdnDomainIspDataResponse is the response struct for api TestAmpDescribeScdnDomainIspData
type TestAmpDescribeScdnDomainIspDataResponse struct {
	*responses.BaseResponse
	EndTime      string                                  `json:"EndTime" xml:"EndTime"`
	StartTime    string                                  `json:"StartTime" xml:"StartTime"`
	RequestId    string                                  `json:"RequestId" xml:"RequestId"`
	DomainName   string                                  `json:"DomainName" xml:"DomainName"`
	DataInterval string                                  `json:"DataInterval" xml:"DataInterval"`
	Value        ValueInTestAmpDescribeScdnDomainIspData `json:"Value" xml:"Value"`
}

// CreateTestAmpDescribeScdnDomainIspDataRequest creates a request to invoke TestAmpDescribeScdnDomainIspData API
func CreateTestAmpDescribeScdnDomainIspDataRequest() (request *TestAmpDescribeScdnDomainIspDataRequest) {
	request = &TestAmpDescribeScdnDomainIspDataRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("scdn", "2017-11-15", "TestAmpDescribeScdnDomainIspData", "", "")
	request.Method = requests.POST
	return
}

// CreateTestAmpDescribeScdnDomainIspDataResponse creates a response to parse from TestAmpDescribeScdnDomainIspData response
func CreateTestAmpDescribeScdnDomainIspDataResponse() (response *TestAmpDescribeScdnDomainIspDataResponse) {
	response = &TestAmpDescribeScdnDomainIspDataResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
