package vpc

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DetachVpnAttachment invokes the vpc.DetachVpnAttachment API synchronously
func (client *Client) DetachVpnAttachment(request *DetachVpnAttachmentRequest) (response *DetachVpnAttachmentResponse, err error) {
	response = CreateDetachVpnAttachmentResponse()
	err = client.DoAction(request, response)
	return
}

// DetachVpnAttachmentWithChan invokes the vpc.DetachVpnAttachment API asynchronously
func (client *Client) DetachVpnAttachmentWithChan(request *DetachVpnAttachmentRequest) (<-chan *DetachVpnAttachmentResponse, <-chan error) {
	responseChan := make(chan *DetachVpnAttachmentResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DetachVpnAttachment(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DetachVpnAttachmentWithCallback invokes the vpc.DetachVpnAttachment API asynchronously
func (client *Client) DetachVpnAttachmentWithCallback(request *DetachVpnAttachmentRequest, callback func(response *DetachVpnAttachmentResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DetachVpnAttachmentResponse
		var err error
		defer close(result)
		response, err = client.DetachVpnAttachment(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DetachVpnAttachmentRequest is the request struct for api DetachVpnAttachment
type DetachVpnAttachmentRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	ClientToken          string           `position:"Query" name:"ClientToken"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	VpnConnectionId      string           `position:"Query" name:"VpnConnectionId"`
}

// DetachVpnAttachmentResponse is the response struct for api DetachVpnAttachment
type DetachVpnAttachmentResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateDetachVpnAttachmentRequest creates a request to invoke DetachVpnAttachment API
func CreateDetachVpnAttachmentRequest() (request *DetachVpnAttachmentRequest) {
	request = &DetachVpnAttachmentRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Vpc", "2016-04-28", "DetachVpnAttachment", "vpc", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDetachVpnAttachmentResponse creates a response to parse from DetachVpnAttachment response
func CreateDetachVpnAttachmentResponse() (response *DetachVpnAttachmentResponse) {
	response = &DetachVpnAttachmentResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
